#define USE_MPFI
#include "many.h"

int
main (int argc, char *argv[])
{
  unsigned long N = atoi (argv[1]);
  mp_prec_t p;
  mpfi_t i, j;
  char *lo, *hi;
  mp_exp_t exp_lo, exp_hi;
  int st;

  fprintf (stderr, "Using GMP %s and MPFR %s\n", gmp_version, mpfr_version);
  st = cputime ();

  /* initial estimate of the working precision */
  p = (mp_prec_t) (3.321928095 * (double) N + 10.0 + 22.0);
  fprintf (stderr, "Setting initial precision to %lu\n", p);
  
  mpfi_init (i);
  mpfi_init (j);
  mpfi_set_prec (j, 2);

  do
    {
      mpfi_set_prec (i, p);

      mpfi_set_d (j, 0.5);
      mpfi_exp (i, j);
      mpfi_exp (i, i);
      mpfi_exp (i, i);
      mpfi_sub_ui (i, i, 181);

      lo = mpfr_get_str (NULL, &exp_lo, 10, N, LEFT(i), GMP_RNDZ);
      hi = mpfr_get_str (NULL, &exp_hi, 10, N, RIGHT(i), GMP_RNDZ);
      if (exp_lo == exp_hi && strcmp (lo, hi) == 0)
        break;
      else
        {
          p += 10;
          fprintf (stderr, "Increasing precision to %lu\n", p);
        }
    }
  while (1);

  printf ("%s\n", lo);

  mpfi_clear (i);
  mpfi_clear (j);

  fprintf (stderr, "Cputime: %dms\n", cputime () - st);
  return 0;
}
