#include "many.h"

/* Error analysis not done yet, since there is probably a faster solution. */

static void
compval (mpfr_t x, mp_prec_t p)
{
  mpfr_set_prec (x, p);
  mpfr_const_pi (x, GMP_RNDN);
  mpfr_pow_ui (x, x, 1000, GMP_RNDN);
}

int
main (int argc, char *argv[])
{
  unsigned long N = atoi (argv[1]), M;
  mp_prec_t p;
  mpfr_t i, j;
  char *lo;
  mp_exp_t exp_lo;
  int st, st0;

  fprintf (stderr, "Using GMP %s and MPFR %s\n", gmp_version, mpfr_version);
  st = cputime ();

  mpfr_init (i);
  mpfr_init (j);

  M = N;

  do
    {
      M += 10;
      mpfr_set_prec (i, 32);
      mpfr_set_d (i, LOG2_10, GMP_RNDU);
      mpfr_mul_ui (i, i, M, GMP_RNDU);
      mpfr_add_ui (i, i, 1650, GMP_RNDU);
      p = mpfr_get_ui (i, GMP_RNDU);
      fprintf (stderr, "Setting precision to %lu\n", p);
      compval (i, p);
      st0 = cputime ();
      lo = mpfr_get_str (NULL, &exp_lo, 10, M + 498, i, GMP_RNDN);
      st0 = cputime () - st0;
    }
  while (can_round (lo + 498, N, M) == 0);

  lo += 498;
  lo[N] = '\0';
  printf ("%s\n", lo);

  mpfr_clear (i);

  fprintf (stderr, "Cputime: %dms (output %dms)\n", cputime () - st, st0);
  return 0;
}
