#include "many.h"

#define CONST 438.28595410261431 /* upper approximation of 100*log(a)/log(2)
				    where a = 10+sqrt(118). */

int
main (int argc, char *argv[])
{
  unsigned long N = atoi (argv[1]), M;
  mp_prec_t p;
  mpfr_t h, i, j;
  mpfr_ptr t[4];
  char *lo;
  mp_exp_t exp_lo;
  int k;
  int st, st0;

  fprintf (stderr, "Using GMP %s and MPFR %s\n", gmp_version, mpfr_version);
  st = cputime ();

  mpfr_init (h);
  mpfr_init (i);
  mpfr_init (j);

  M = 8 * N;

  do
    {
      M += 10;
      p = atoi (argv[2]);
      fprintf (stderr, "Setting precision to %lu\n", p);

      mpfr_set_prec (h, p);
      mpfr_set_prec (i, p);
      mpfr_set_prec (j, p);

      t[0] = h;
      mpfr_set_ui (h, 14, GMP_RNDN);
      mpfr_div_ui (h, h, 3, GMP_RNDN); /* a0 = 14/3 */

      t[1] = i;
      mpfr_set_ui (i, 5, GMP_RNDN); /* a1 = 5 */

      t[2] = j;
      mpfr_set_ui (j, 184, GMP_RNDN);
      mpfr_div_ui (j, j, 35, GMP_RNDN); /* a1 = 184/35 */

      for (k = 0; k < 100 * (int) N; k++)
        {
          mpfr_ui_div (t[0], 9000, t[0], GMP_RNDN);
          mpfr_ui_sub (t[0], 6390, t[0], GMP_RNDN);
          mpfr_div (t[0], t[0], t[1], GMP_RNDN);
          mpfr_ui_sub (t[0], 1463, t[0], GMP_RNDN);
          mpfr_div (t[0], t[0], t[2], GMP_RNDN);
          mpfr_ui_sub (t[0], 114, t[0], GMP_RNDN);
          t[3] = t[0];
          t[0] = t[1];
          t[1] = t[2];
          t[2] = t[3];
        }

      st0 = cputime ();
      lo = mpfr_get_str (NULL, &exp_lo, 10, M + 1, t[2], GMP_RNDN);
      st0 = cputime () - st0;
    }
  while (can_round (lo + 1, N, M) == 0);

  lo += 3; /* to skip the initial 5 */
  lo[N] = '\0';
  printf ("%s\n", lo);

  mpfr_clear (i);
  mpfr_clear (j);

  fprintf (stderr, "Cputime: %dms (output %dms)\n", cputime () - st, st0);
  return 0;
}
