/* crq.h -- public header file.

Copyright 2005 Laurent Fousse <laurent@komite.net>

This file is part of the CRQ Library.

The CRQ Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The CRQ Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the CRQ Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Place, Fifth Floor, Boston,
MA 02110-1301, USA. */

#ifndef _INTLIB_H
#define _INTLIB_H

#include <mpfr.h>
#include "crq_structs.h"

/* Integration methods */
void compose_gl (mpfr_t, mpfr_t, mpfr_t, mpfr_t, unsigned int,
		 unsigned int, aqfunc_t, mpfr_t, mp_prec_t, int, char *);
void compose_gl_stats (mpfr_t, mpfr_t, mpfr_t, mpfr_t, unsigned int,
		 unsigned int, aqfunc_t, mpfr_t, mp_prec_t, int, char *,
		 struct crq_stats *);
void compose_nc (mpfr_t, mpfr_t, mpfr_t, unsigned int, unsigned int,
		 aqfunc_t f, mpfr_t, mpfr_t, mp_prec_t);

/* error bounds */
void gl_error (mpfr_t, mpfr_t, mpfr_t b, unsigned int, unsigned int, mpfr_t M);
void nc_closed_error (mpfr_t, mpfr_t a, mpfr_t b, unsigned int n, mpfr_t M);

#endif /* _INTLIB_H */
